#!/usr/local/bin/perl
#################################################################
#             Message Board V4.0.1 (Freeware)
#
# This program is distributed as freeware. We are not            	
# responsible for any damages that the program causes	
# to your system. It may be used and modified free of 
# charge, as long as the copyright notice
# in the program that give me credit remain intact.
# If you find any bugs in this program. It would be thankful
# if you can report it to us at cgifactory@cgi-factory.com.  
# However, that email address above is only for bugs reporting. 
# We will not  respond to the messages that are sent to that 
# address. If you have any trouble installing this program. 
# Please feel free to post a message on our CGI Support Forum.
# Selling this script is absolutely forbidden and illegal.
##################################################################
#
#               COPYRIGHT NOTICE:
#
#         Copyright 1999-2000 CGI-Factory.com TM 
#		  A subsidiary of SiliconSoup.com LLC
#
#
#      Web site: http://www.cgi-factory.com
#      E-Mail: cgifactory@cgi-factory.com
#      Released Date: April 08, 2000
#	
#   Message Board V4.0 is protected by the copyright 
#   laws and international copyright treaties, as well as other 
#   intellectual property laws and treaties.
###################################################################
#don't change these two vairables unless you know what you are doing
$main_admin="message-admin.pl";
$configur_admin="configur.pl";
##############################
#filename for the variable files 
$mcfg="mcfg.pl";
$mgcfg="mgcfg.pl";
$vcfg="vcfg.pl";
#filename for superuser.db
$superuser="superuser.db";
#############################
#import variables. However, use eval to avoid 500 error message 
#when something goes wrong
eval {
require "$mcfg";
require "$vcfg";
require "$mgcfg";
};
if ($@) {
print "Content-type: text/html\n\n";
print "Error in $mcfg, $vcfg, or mgcfg.pl<br><br>
If you don't know how to fix this problem or you are using Windows NT servers,
please check out our faq section or use our technical support forum at <a href=\"http://www.cgi-factory.com\">cgi-factory.com</a>.
<br><br>Error Message:<br> $@";
exit;
}
#
read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
($name, $value) = split(/=/, $pair);
$value =~ tr/+/ /;
$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
$request{$name} = $value;
}
print "Content-type: text/html\n\n";

#
open (DETECT,"<$superuser") or &decide;
if ($flock eq "y") {
flock DETECT, 2; 
}
@detect=<DETECT>;
close (DETECT);
if (!@detect) {
&decide;
}
sub decide {
if ($request{'action'} eq "firsttime") {
&firsttime;
exit;
}
else {
&setup;	
exit;
}
}
if ($request{'action'} eq "main_page") {
&main_page;
exit;
}
if ($request{'action'} eq "save") {
&save;
exit;
}

print <<EOF;
<HTML>
<HEAD>
<TITLE>Advanced Message Board V4.0</TITLE>
</HEAD>
<BODY bgcolor="#ffffff">
<center>
<font face="Arial"><font size="+2">Freeware Message Board V4.0 Configuration</font><br><br>
Please enter your Super user admin name and password to Login:
<form action="$configur_admin" method="post">
<b>Super User Admin Name:</b> <input type="text" name="admin">&nbsp;&nbsp;
<b>Password:</b> <input type="password" name="password">
<input type="hidden" name="action" value="main_page">
<input type="submit" value="ok">
</form></center>
</body>
</html>
EOF
exit;

# main page
sub main_page {
&vpassword;

open (content, "<$bdata/board1.bd") or @content="";
if ($flock eq "y") {
flock content, 2; 
}
@content=<content>;
close (content);
chomp(@content[3]);

print <<EOF;
<html>
<head>
<title>Freeware Message Board V4.0 Configuration</title>
</head><body bgcolor="#ffffff">
<font size="+2" face="arial"><b>Freeware Message Board V4.0 Configuration</b></font><br><table><tr bgcolor="#FFFFC6"><td><hr>
<br><br><b>Settings that are shared by both view.pl and message.pl</b><br><br><form action="$configur_admin" method="POST">
The full system path to the directory where stores the data files for the message boards(no back slash at the end) <input type="Text" name="bdata" value="$bdata" size="60"><br><br>
The WWW path to message.pl. Includes itself <input type="Text" name="cgi" value="$cgi" size="60"><br><br>
The WWW path to view.pl. Includes itself <input type="Text" name="cgi2" value="$cgi2" size="60"><br><br>
The file name ending for the created message. for example, shtml , htm, or html <input type="Text" name="file_ending" value="$file_ending" size="30"><br><br>
The WWW Path to the default icon image. <input type="Text" name="default_icon" value="$default_icon" size="60"><br><br>
Time Format (1-3):  <input type="Text" name="date_format" value="$date_format" size="1"> (1: Long Format, 2: dd/mm/year, 3: mm/dd/year)
<br><br>
Time Difference (hours or -hours):  <input type="Text" name="time_differ" value="$time_differ" size="3" maxlength="3"><br><br>
Show the title(name) of a message board?(y/n) <font color="red">lower letter-case only</font><input type="Text" name="btitle" value="$btitle" size="1"><br><br>
The text color for the page spliting links, post box, and reply box. <input type="Text" name="other_color" value="$other_color" size="30"><br><br>
The font face for the whole message board <input type="Text" name="font_face" value="$font_face" size="10"><br><br>
The font size for the entries listed on the message board main page (view.pl) <input type="Text" name="font_size" value="$font_size" size="10"><br><br>
File locking. Don't set it to "n" unless your system really have trouble using flock. Turn it off at your own risk. (y/n) <font color="red">lower letter-case only</font><input type="Text" name="flock" value="$flock" size="1"><br><br>
Send an alert mail to yourself when someone trys to gain access to the admin script with an incorrect login. This feature will not work with sendmail. However, login errors will be logged in errorlog.txt.(y/n) <font color="red">lower letter-case only</font><input type="Text" name="alert" value="$alert" size="1"><br><br>
Your email address. (<font color="red">NO</font> back slash in front of the symbol @) <input type="Text" name="yourmail" value="$yourmail" size="30"><br><br>
Sending mail options <font color="red">0: sendmail 1: SMTP</font><input type="Text" name="mail_option" value="$mail_option" size="1"><br>
The full system path to the mail program (sendmail) or the smtp server(SMTP) (remove <font color="red">-t</font> for sendmail path if it causes error)<input type="Text" name="mailprog" value="$mailprog" size="30"><br><br>
Reply Email notification for the visitors.(y/n) <font color="red">lower letter-case only</font><input type="Text" name="replymail" value="$replymail" size="1"><br><br>

<hr></td></tr><tr bgcolor="#FFFFDF"><td><br><br>
<b>Settings that are used by view.pl</b>(They are used for the message indexing main page)<br><br>
Max number of messages to be listed by view.pl <input type="Text" name="max" value="$max" size="10"><br><br>
Allow visitors to search for messages.(y/n) <font color="red">lower letter-case only</font><input type="Text" name="a_search" value="$a_search" size="1"><br><br>
The color of the title bar <input type="Text" name="title_color" value="$title_color" size="30"><br><br>
The color of the title bar text <input type="Text" name="title_text" value="$title_text" size="30"><br><br>
The color of the "subject" field <input type="Text" name="topic_color" value="$topic_color" size="30"><br><br>
The color of the "replies" field <input type="Text" name="replies_color" value="$replies_color" size="30"><br><br>
The color of the "from" field <input type="Text" name="post_color" value="$post_color" size="30"><br><br>
The color of the "last post" field <input type="Text" name="lastpost_color" value="$lastpost_color" size="30"><br><br>
The color of the text in the "subject" field <input type="Text" name="topic_text" value="$topic_text" size="30"><br><br>
The color of the text in the "replies" field <input type="Text" name="replies_text" value="$replies_text" size="30"><br><br>
The color of the text in the "from" field <input type="Text" name="post_text" value="$post_text" size="30"><br><br>
The color of the text in the "last post" field <input type="Text" name="lastpost_text" value="$lastpost_text" size="30"><br><br>
The width of the message index table <input type="Text" name="table_width" value="$table_width" size="4"><br><br>
The width of the "last post" field <input type="Text" name="post_width" value="$post_width" size="4"><br><br>
<hr></td></tr><tr bgcolor="#FFFFC6"><td><br><br>
<b>Settings that are used by message.pl</b>(They are used for posting messages)<br><br>
The name of your web site <input type="Text" name="sitetitle" value="$sitetitle" size="30"><br><br>
Max number of reply messages allowed on each post (0=no limit)<input type="Text" name="max_reply" value="$max_reply" size="10"><br><br>
Allow html tags when a visitor posts a message?(y/n) <font color="red">lower letter-case only</font><input type="Text" name="html" value="$html" size="1"><br><br>
Name field required?(y/n) <font color="red">lower letter-case only</font><input type="Text" name="require_name" value="$require_name" size="1"><br><br>
Subject field required?(y/n) <font color="red">lower letter-case only</font><input type="Text" name="require_subject" value="$require_subject" size="1"><br><br>
Email field required?(y/n) <font color="red">lower letter-case only</font><input type="Text" name="require_email" value="$require_email" size="1"><br><br>
The color of the first message field <input type="Text" name="message_color" value="$message_color" size="30"><br><br>
The color of the reply message fields <input type="Text" name="reply_color" value="$reply_color" size="30"><br><br>
The color of the text in the first message field <input type="Text" name="message_text" value="$message_text" size="30"><br><br>
The color of the text in the reply message fields <input type="Text" name="reply_text" value="$reply_text" size="30"><br><br>
The color of the title bar for posted messages <input type="Text" name="mbar" value="$mbar" size="30"><br><br>
The color of the text in the title bar for posted messages <input type="Text" name="mbar_text" value="$mbar_text" size="30"><br><br>
The width of messages <input type="Text" name="message_width" value="$message_width" size="30"><br><br>
</td></tr>
<tr bgcolor="#FFFFDF"><td><br><br>
<b>The configuration for the message board</b><br><br>
<table>
<tr><td>
<form action="$main_admin" method="post">
<input type="hidden" name="admin" value="$request{'admin'}">
<input type="hidden" name="password" value="$request{'password'}">
<input type="hidden" name="paction" value="main_one">
<input type="hidden" name="nick" value="$request{'board'}">
<input type="hidden" name="action" value="modify_con">  
</td><td></td></tr>
<tr><td>Name or title of the Message Board</td><td><input type="text" name="forum_name" value="@content[2]"></td></tr>
<tr><td>Full System path the the message directory</td><td><input type="text" name="full" value="@content[0]"></td></tr>
<tr><td>WWW path the the message directory</td><td><input type="text" name="www" value="@content[1]"></td></tr>
<tr><td>Public Board? (This variable is used in Advanced Message Board V4.0)</td><td>

EOF

if (@content[3]==0) {
print "<input type=\"radio\" name=\"vis\" value=\"1\">Yes <input type=\"radio\" name=\"vis\" value=\"0\" checked>No(Private)</td></tr>";
}
else {
print "<input type=\"radio\" name=\"vis\" value=\"1\" checked>Yes <input type=\"radio\" name=\"vis\" value=\"0\">No(Private)</td></tr>";
}	
print "<tr><td>Board mode (opened: accepts new messages; closed: does not accept any new message): </td><td>";
if (@content[4]==0) {
print "<input type=\"radio\" name=\"mode\" value=\"1\">Opened <input type=\"radio\" name=\"mode\" value=\"0\" checked>Closed</td></tr>";
}
else {
print "<input type=\"radio\" name=\"mode\" value=\"1\" checked>Opened <input type=\"radio\" name=\"mode\" value=\"0\">Closed</td></tr>";
}
print "</td></tr></table>
<input type=\"hidden\" name=\"admin\" value=\"$request{'admin'}\"><input type=\"hidden\" name=\"password\" value=\"$request{'password'}\">
<input type=\"hidden\" name=\"action\" value=\"save\"><input type=\"submit\" value=\"Save the configuration\"></form></td></tr></table>
<center>Copyright 1999-2000 CGI-Factory.com</center></body></html>";

exit;
}
####### save change

sub save {
&vpassword;	
$request{'yourmail'}=~ s/@/\\@/g;
open (main, ">$mcfg") or &error("Unable to write to mcfg.pl. Please make sure you have chmoded it to \"755\"(chmod it to \"777\" if it still doesn't work)");
if ($flock eq "y") {
flock main, 2; 
} 
print main "\$bdata=\"$request{'bdata'}\"\;\n";
print main "\$cgi=\"$request{'cgi'}\"\;\n";
print main "\$cgi2=\"$request{'cgi2'}\"\;\n";
print main "\$search=\"$request{'search'}\"\;\n";
print main "\$file_ending=\"$request{'file_ending'}\"\;\n";
print main "\$default_icon=\"$request{'default_icon'}\"\;\n";
print main "\$date_format=\"$request{'date_format'}\"\;\n";
print main "\$time_differ=\"$request{'time_differ'}\"\;\n";
print main "\$btitle=\"$request{'btitle'}\"\;\n";
print main "\$other_color=\"$request{'other_color'}\"\;\n";
print main "\$font_face=\"$request{'font_face'}\"\;\n";
print main "\$font_size=\"$request{'font_size'}\"\;\n";
print main "\$flock=\"$request{'flock'}\"\;\n";
print main "\$alert=\"$request{'alert'}\"\;\n";
print main "\$yourmail=\"$request{'yourmail'}\"\;\n";
print main "\$mail_option=\"$request{'mail_option'}\"\;\n";
print main "\$mailprog=\"$request{'mailprog'}\"\;\n";
print main "\$replymail=\"$request{'replymail'}\"\;\n";
print main "\$opticon=\"$request{'opticon'}\"\;\n";
print main "1\;\n";

close(main);

open (view, ">$vcfg") or &error("Unable to write to vcfg.pl. Please make sure you have chmoded it to \"755\"(chmod it to \"777\" if it still doesn't work)");
if ($flock eq "y") {
flock view, 2; 
} 
print view "\$max=\"$request{'max'}\"\;\n";
print view "\$a_search=\"$request{'a_search'}\"\;\n";
print view "\$title_color=\"$request{'title_color'}\"\;\n";
print view "\$title_text=\"$request{'title_text'}\"\;\n";
print view "\$topic_color=\"$request{'topic_color'}\"\;\n";
print view "\$replies_color=\"$request{'replies_color'}\"\;\n";
print view "\$post_color=\"$request{'post_color'}\"\;\n";
print view "\$lastpost_color=\"$request{'lastpost_color'}\"\;\n";
print view "\$topic_text=\"$request{'topic_text'}\"\;\n";
print view "\$replies_text=\"$request{'replies_text'}\"\;\n";
print view "\$post_text=\"$request{'post_text'}\"\;\n";
print view "\$lastpost_text=\"$request{'lastpost_text'}\"\;\n";
print view "\$table_width=\"$request{'table_width'}\"\;\n";
print view "\$post_width=\"$request{'post_width'}\"\;\n";
print view "1\;\n";
close(view);

open (message, ">$mgcfg") or &error("Unable to write to mgcfg.pl. Please make sure you have chmoded it to \"755\"(chmod it to \"777\" if it still doesn't work)");
if ($flock eq "y") {
flock message, 2; 
} 
print message "\$sitetitle=\"$request{'sitetitle'}\"\;\n";
print message "\$max_reply=\"$request{'max_reply'}\"\;\n";
print message "\$html=\"$request{'html'}\"\;\n";
print message "\$require_name=\"$request{'require_name'}\"\;\n";
print message "\$require_subject=\"$request{'require_subject'}\"\;\n";
print message "\$require_email=\"$request{'require_email'}\"\;\n";
print message "\$filter=\"$request{'filter'}\"\;\n";
print message "\$message_color=\"$request{'message_color'}\"\;\n";
print message "\$reply_color=\"$request{'reply_color'}\"\;\n";
print message "\$message_text=\"$request{'message_text'}\"\;\n";
print message "\$reply_text=\"$request{'reply_text'}\"\;\n";
print message "\$mbar=\"$request{'mbar'}\"\;\n";
print message "\$mbar_text=\"$request{'mbar_text'}\"\;\n";
print message "\$message_width=\"$request{'message_width'}\"\;\n";
print message "1\;\n";
close(message);

open (board, ">$request{'bdata'}/board1.bd") or &error("Unable to write to board1.bd in the data directory.");
if ($flock eq "y") {
flock board, 2; 
}
print board "$request{'full'}\n";
print board "$request{'www'}\n";
print board "$request{'forum_name'}\n";
print board "$request{'vis'}\n";
print board "$request{'mode'}\n";
close (board);
	
print "The new configuration has been saved. If anything doesn't work out, you can run $configur_admin again to change the setting again.
<font size=\"-1\"><b>Warning: Please close your browser if you want to log off.</b><br><br><br>
Copyright 1999-2000 CGI-Factory.com</font>";
exit;
}	
###### password

sub vpassword{
if (!$ENV{'REMOTE_HOST'}) {
$IP=$ENV{'REMOTE_ADDR'};
}
else {
$IP=$ENV{'REMOTE_HOST'};
}
open (pass, "<$superuser") or &error("Unable to open the admin data.");
if ($flock==1) {
flock pass, 2; 
}
$pass=<pass>;
close(pass);

$compare=$request{'admin'};
$compare=~ tr/A-Z/a-z/;
$compare=~ s/\s//;
chomp($pass);
@check=split(/\|/, $pass);
if ($compare eq "@check[0]" and $compare == "@check[0]") {
$ok=1;
$request{'password'}=~ tr/A-Z/a-z/;
$password=crypt("$request{'password'}", YL);
unless ($password eq "@check[1]") {
&wrong;
}
}
unless ($ok==1) {
&wrong;	
}
}	

sub wrong {
$timenow=localtime();
print "<h2>Incorrect login</h2>";
print "The password you entered is incorrect.<br>";
print "The following information has been sent to the webmaster of the web site for security reasons.<br>";
print "<ul>Your IP Address: $IP</ul>";
print "<ul>Admin Name you tried: $request{'admin'}</ul>";
print "<ul>Password your entered: $request{'password'}</ul>";
print "<ul>Time: $timenow</ul>";

open (errorlog, ">>errorlog.txt") or &error("unable to write to errorlog.txt");
if ($flock eq "y") {
flock errorlog, 2; 
}
print errorlog "IP: $IP| admin: $request{'admin'}| pass: $request{'password'}| time: $timenow\n";
close (errorlog);

if ($alert eq "y") {
open (MAIL, "|$mailprog") or &error("Unable to open the mail program");
print MAIL "To: $yourmail\n";
print MAIL "From: $yourmail\n";
print MAIL "Subject: bad password\n";
print MAIL "someone entered the wrong password for entering the admin script.\n";
print MAIL "Here is information:\n\n";
print MAIL "IP Address: $IP\n";
print MAIL "Admin Name: $request{'admin'}\n";
print MAIL "Password: $request{'password'}\n";
print MAIL "$timenow\n";
close(MAIL);
}
exit;	
}	
####
sub setup {

print "This is the first time you run this script or you may have deleted the password file by mistake.\n";
print "Please set up your admin name and password:<br>\n";
print "<form action=\"$configur_admin\" method=\"post\">\n";
print "Admin Name:<input type=\"text\" name=\"admin_name\"><br>\n";
print "Password:<input type=\"text\" name=\"password1\"><br>\n";
print "Enter the passward again:<input type=\"text\" name=\"password2\">\n";
print "<input type=\"hidden\" name=\"action\" value=\"firsttime\">\n";
print "<input type=\"submit\" value=\"OK\"></form>";
exit;

}

sub firsttime {
if ($request{'admin_name'} eq "" and !$request{'admin_name'}) {
print "Please don't leave the admin name filed blank!";
exit;
}
if ($request{'password1'} eq "" and !$request{'password1'}) {
print "Please don't leave the password field blank!";
exit;
}
if ($request{'password2'} eq "" and !$request{'password2'}) {
print "Please don't leave the password field blank!";
exit;
}
if ($request{'password1'} ne "$request{'password2'}" and $request{'password1'} != $request{'password2'}){
print "You entered two different passwords. Please try again!";
exit;
}
$request{'admin_name'}=~ tr/A-Z/a-z/; 
$request{'admin_name'}=~ tr/\s//;
$request{'password1'}=~ tr/A-Z/a-z/; 
$password = crypt($request{'password1'}, "YL");	
    
open (PASSWORD, ">$superuser") or &error("unable to create the password file");
if ($flock eq "y") {
flock PASSWORD, 2; 
}
print PASSWORD "$request{'admin_name'}|$password";
close (PASSWORD);
print "<h2>New admin name and password are saved. Please reload this page to continue setting up this message board.</h2>\n";
exit;
}

#####error
sub error {
print "<h2>An error has occured</h2> The error is $_[0]<br>\n";	
print "$!\n<br><br>";
print "If the error message is \"No such file or directory,\" please make sure the system path your are using is correct.<br>\n";
print "Also, you need to make sure you have uploaded the file or created the directory as it explains in the read me file.<br><br>\n";	
print "If the error message is \"permission denied,\" please make sure you have chmoded the file as it explains in the read me file.<br>\n";	
exit;	
}
 
	
	
	











